<?php
namespace SmartData;

abstract class KairosGetter {
    const HOST = 'iot.lisha.ufsc.br';
    const PORT = 8080;
    const QUERY_SUFFIX = '/api/v1/datapoints/query';

    private function __construct(){}

    private static function build_query_data_url(){
        return 'http://' . self::HOST . ':' . self::PORT . self::QUERY_SUFFIX;
    }

    public static function query($metric_name, $start_absolute, $end_absolute){
        $json = array();
        $json['start_absolute'] = $start_absolute;
        $json['end_absolute'] = $end_absolute;
        $json['metrics'] = array();
        $json['metrics'][0] = array();
        $json['metrics'][0]['name'] = $metric_name;

        $url = self::build_query_data_url();
        $options = array(
            'http' => array(
                'header' => "Content-type: application/json",
                'method' => 'POST',
                'content' => json_encode($json)
            )
        );
        $context = stream_context_create($options);
        $response = file_get_contents($url, false, $context);
        return $response;
    }
}