<?php

namespace SmartData;

require_once('../API.php');

$t1 = (int) round(microtime(true)*1000); // get current timestamp in milliseconds
$series = array();

// Configure below the series to import

//$t0 = 1483228800000; // Jan. 1 2017,
//$t0 = 1465095600000; // Jun. 5 2016,
$time_interval = 1000 * 60 * 60 * 24 * 7; // One week
$t0 = $t1 - $time_interval;
$t = $t0 + $time_interval;
while($t <= $t1) {
    // River level sensor "f1"
    array_push($series, array(
        'name' => 'h_f1_lvl',
        't0' => $t0,
        't1' => $t,
        'unit' => 2224441636, // Length
        'error' => 0,
        'confidence' => 0,
        'x' =>  374675900,
        'y' => -423761000,
        'z' => -293718800,
        'domain' => 'public',
        'username' => 'public2',
        'password' => 'pu3l1c2018'
    ));
    // River level sensor "f5"
    array_push($series, array(
        'name' => 'h_f5_lvl',
        't0' => $t0,
        't1' => $t,
        'unit' => 2224441636, // Length
        'error' => 0,
        'confidence' => 0,
        'x' =>  374639000,
        'y' => -423757600,
        'z' => -293770200,
        'domain' => 'public',
        'username' => 'public2',
        'password' => 'pu3l1c2018'
    ));
    // River level sensor "f7"
    array_push($series, array(
        'name' => 'h_f7_lvl',
        't0' => $t0,
        't1' => $t,
        'unit' => 2224441636, // Length
        'error' => 0,
        'confidence' => 0,
        'x' =>  374642500,
        'y' => -423784600,
        'z' => -293727600,
        'domain' => 'public',
        'username' => 'public2',
        'password' => 'pu3l1c2018'
    ));
#    array_push($series, array(
#        'name' => 'A0numeric0', // SSB lights A0
#        't0' => $t0,
#        't1' => $t,
#        'domain' => 'smartsolarbuilding',
#        'username' => 'smartsolarbuilding',
#        'password' => 'smartsolarbuilding@12a06-fs',
#        'unit' => 2224180004, // Current
#        'error' => 0,
#        'confidence' => 0,
#        'x' => 75270643,
#        'y' => 696322600,
#        'z' => 101750
#    ));
     $t0 = $t + 1;
     $t = $t0 + $time_interval - 1;
}

// LISHA outlet 0
#array_push($series, array(
#    'name' => '00244b9284e204382c4b2b8528c5620000000000000000000000000000ffffffffffffffff',
#    't0' => 1498867200000, // July 1st 2017
#    't1' => $t1,
#    'domain' => 'smartlisha',
#    'username' => 'smartlisha',
#    'password' => 'smartlisha@12a06-fs'
#));
// LISHA luminosity sensor
#array_push($series, array(
#    'name' => '00254992842003382c3b2c8528d4620000000000000000000000000000ffffffffffffffff',
#    't0' => 1498867200000, // July 1st 2017
#    't1' => $t1,
#    'domain' => 'smartlisha',
#    'username' => 'smartlisha',
#    'password' => 'smartlisha@12a06-fs'
#));
// LISHA Lights sensor
#array_push($series, array(
#    'name' => '00244b92844704382c9b2b8528b0630000000000000000000000000000ffffffffffffffff',
#    't0' => 1498867200000, // July 1st 2017
#    't1' => $t1,
#    'domain' => 'smartlisha',
#    'username' => 'smartlisha',
#    'password' => 'smartlisha@12a06-fs'
#));
// HU Water Flow meter
#array_push($series, array(
#    'name' => '00fc7fcf9fa7b2700490226529d4620000000000000000000000000000ffffffffffffffff',
#    't0' => 1506643200000, // September 29th 2017
#    't1' => $t1
#));

class KairosGetter {
    const KAIROS_IP = 'iot.lisha.ufsc.br';
    const KAIROS_PORT = 8080;
    const KAIROS_QUERY_DATA_SUFFIX = '/api/v1/datapoints/query';

    private function __construct(){}

    private static function build_query_data_url(){
        return 'http://' . KairosGetter::KAIROS_IP . ':' . KairosGetter::KAIROS_PORT . KairosGetter::KAIROS_QUERY_DATA_SUFFIX;
    }

    public static function query_data_from_kairos($metric_name, $start_absolute, $end_absolute){

        $put_json = array();
        $put_json['start_absolute'] = $start_absolute;
        $put_json['end_absolute'] = $end_absolute;
        $put_json['metrics'] = array();
        $put_json['metrics'][0] = array();
        $put_json['metrics'][0]['name'] = $metric_name;

        $url = KairosGetter::build_query_data_url();
        $options = array(
            'http' => array(
                'header' => "Content-type: application/json",
                'method' => 'POST',
                'content' => json_encode($put_json)
            )
        );

        $context = stream_context_create($options);
        $response = file_get_contents($url, false, $context);
        return $response;
    }
}

function secondsToTime($s)
{
    $h = floor($s / 3600);
    $s -= $h * 3600;
    $m = floor($s / 60);
    $s -= $m * 60;
    return $h.':'.sprintf('%02d', $m).':'.sprintf('%02d', $s);
}

$n_imports = 0;
$start_time = microtime(true);

foreach($series as $s) {
    $start_time_series = microtime(true);

    echo "--------------------------------------------\n";
    echo "Importing series named " . $s['name'] . "\n";
    echo "Querying kairos...\n";
    $json = KairosGetter::query_data_from_kairos($s['name'], $s['t0'], $s['t1']);
    echo "Returned data size = " . strlen($json) . "\n";
    echo "Decoding JSON...\n";
    $json = json_decode($json, true);

    if(array_key_exists('unit', $s)) $unit = $s['unit'];
    else $unit = $json['queries'][0]['results'][0]['tags']['unit'][0];

    if(array_key_exists('confidence', $s)) $confidence = $s['confidence'];
    else $confidence = 0;

    if(array_key_exists('error', $s)) $error = $s['error'];
    else $error = $json['queries'][0]['results'][0]['tags']['error'][0];

    if(array_key_exists('x', $s)) $x = $s['x'];
    else $x = $json['queries'][0]['results'][0]['tags']['pos_x'][0];

    if(array_key_exists('y', $s)) $y = $s['y'];
    else $y = $json['queries'][0]['results'][0]['tags']['pos_y'][0];

    if(array_key_exists('z', $s)) $z = $s['z'];
    else $z = $json['queries'][0]['results'][0]['tags']['pos_z'][0];

	$gateway_ip = '127.0.0.1';//Gateway::getAddr();
	$gateway_name = gethostbyaddr($gateway_ip);

	@$domain   = $s['domain'];
	@$username = $s['username'];
	@$password = $s['password'];

    echo "Domain = " . $domain . "\n";
    echo "Username = " . $username . "\n";
    echo "Password = " . $password . "\n";

	$db = new Backend($domain, $username, $password, true);
    $gateway = new Gateway($gateway_ip, $gateway_name);

    $smartdata = new StaticSmartData (
            $unit,
            0,      // value
            $error,
            0,      // confidence
            $x,
            $y,
            $z,
            0,      // timestamp
            0,      // MAC
            $gateway
    );

    $smartdata_series = new Series (
                SmartData::STATIC_VERSION,
                $unit,    // unit
                $x,       // x
                $y,       // y
                $z,       // z
                0,        // r
                $s['t0'] * 1000, // t0 (epoch in microseconds)
                $s['t1'] * 1000  // t1 (epoch in microseconds)
    );

    echo "Attaching data series...\n";
    $db->attach($smartdata_series);

    echo "Pushing data...\n";
    $i = 0;
    foreach($json['queries'][0]['results'][0]['values'] as $value) {
        $smartdata->time = $value[0] * 1000;
        $smartdata->value = $value[1];
        $db->insert($smartdata);
        if($i % 500 == 0)
            echo "\r " . $i . " datapoints imported";
        $i = $i + 1;
    }
    echo "\r " . $i . " datapoints imported\n";
    $n_imports = $n_imports + $i;
    $end_time_series = microtime(true);
    $elapsed = $end_time_series - $start_time_series;
    echo "Elapsed time for this series: " . $elapsed . " (" . secondsToTime($elapsed) . ")\n";
}

echo "--------------------------------------------\n";
$end_time = microtime(true);
$elapsed = $end_time - $start_time;
echo "Total number of datapoints imported: " . $n_imports . "\n";
echo "Total time elapsed: " . $elapsed . " (" . secondsToTime($elapsed) . ")\n";
?>
