#!/usr/bin/python3
import time, requests, json, os, ssl, argparse
from requests.adapters import HTTPAdapter
from requests.packages.urllib3.poolmanager import PoolManager

parser = argparse.ArgumentParser(description='Get data to fulfill input buffer')

required = parser.add_argument_group('required named arguments')
required.add_argument('-s','--smartdata', help='The original smartdata', default="")

# workflow configuration parameters
workflow_expiry = 1000*1000000 # 10 sec
windspeed_unit  = 2224437540
workflow_id     = 3
#power_unit     = 2224180004
radius          = 0
domain          = 'aqtech'


def mount_query(timestamp, unit, dev, r, x, y, z):
    query = {
        'series': {
            'version': 1.1,
            't0': timestamp - workflow_expiry,
            't1': timestamp + workflow_expiry,
            'unit': unit, #should use the same unit as the workflow (or be passed as parameter)
            'dev': dev,
            'r': r,
            'x': x,
            'y': y,
            'z': z,
            'workflow': 0 # workflow_id should be the same as the workflow
        },
        'credentials': {
            'domain': 'aqtech',
            'username': 'aqtech',
            'password': 'jP#55Mh@'
        }
    }
    return query

class MyAdapter(HTTPAdapter):
    def init_poolmanager(self, connections, maxsize, block=False):
        self.poolmanager = PoolManager(num_pools=connections,
                                       maxsize=maxsize,
                                       block=block,
                                       ssl_version=ssl.PROTOCOL_TLSv1)

args = vars(parser.parse_args())
# print(args['smartdata'].replace("'",'"')+"\n")
# print(args['smartdata']+"\n")
smartdata = json.loads(args['smartdata'])
query = mount_query(int(smartdata["timestamp"]), 2224437540, smartdata["dev"], 0, smartdata["x"], smartdata["y"], smartdata["z"])

print(json.dumps(query))

get_url ='https://iot.ufsc.br/api/get.php'

#CLIENT_CERTIFICATE = ['client-CERT.pem', 'client-CERT.key']

session = requests.Session()
session.mount('https://', MyAdapter())
session.headers = {'Content-type' : 'application/json'}
#session.cert = CLIENT_CERTIFICATE

response = session.post(get_url, json.dumps(query))

print (str(response.status_code))
if response.status_code == 200:
    data = response.json()
    print(data)
    avg = 0
    size = len(data['series'])
    for i in range(0, len(data['series'])):
        avg += float(data['series'][i]['value'])

    data['series'][0]['value'] = float(avg/size)
    with open('in1_input', 'a') as fifo:
        fifo.write(json.dumps(data['series'][0])+'\n')
        fifo.flush()
# else:
#     json = "{\n{"+json.dumps(smartdata)+"},\n\t\"notify\": {\n\t\t\"severity:\" 10,\n\t\t\"Description:\"\"No windspeed data available for the timestamp range"+smartdata["timestamp"]+" +/-10s.\"}"
#     with open('in3_input', 'a') as fifo:
#         fifo.write(json.dumps(data['series'][0])+'\n')
#         fifo.flush()
