#!/usr/bin/python3
import time, requests, json, os, ssl, argparse
from requests.adapters import HTTPAdapter
from requests.packages.urllib3.poolmanager import PoolManager

parser = argparse.ArgumentParser(description='Get data to fulfill input buffer')

required = parser.add_argument_group('required named arguments')
required.add_argument('-s','--smartdata', help='The original smartdata', default=500)

# workflow configuration parameters
workflow_expiry = 1*1000 # 1 milisec
unit_vibration  = 2224437540
workflow_id     = 6
radius          = 0
domain          = 'aqtech'
username        = 'aqtech'
password        = 'jP#55Mh@'

devs = [3,4,5,6,7,8,9,10]

def mount_query(timestamp, unit, dev, r, x, y, z):
    query = {
        'series': {
            'version': 1.1,
            't0': timestamp - workflow_expiry,
            't1': timestamp + workflow_expiry,
            'unit': unit, #should use the same unit as the workflow (or be passed as parameter)
            'dev': dev,
            'r': r,
            'x': x,
            'y': y,
            'z': z,
            'workflow': workflow_id #should be the same as the workflow
        },
        'credentials': {
            'domain': domain
            'username' : username
            'password' : password
        }
    }

class MyAdapter(HTTPAdapter):
    def init_poolmanager(self, connections, maxsize, block=False):
        self.poolmanager = PoolManager(num_pools=connections,
                                       maxsize=maxsize,
                                       block=block,
                                       ssl_version=ssl.PROTOCOL_TLSv1)

args = vars(parser.parse_args())
smartdata = json.loads(args['smartdata'])
queries = []
for dev in devs:
    #if (dev == smartdata["dev"]):
    #    continue
    queries.append(mount_query(int(smartdata["timestamp"]), 
                    unit_vibration, 
                    dev, 
                    radius, 
                    smartdata["x"], 
                    smartdata["y"], 
                    smartdata["z"]))

get_url ='https://iot.ufsc.br/api/get.php'

#CLIENT_CERTIFICATE = ['client-CERT.pem', 'client-CERT.key']

session = requests.Session()
session.mount('https://', MyAdapter())
session.headers = {'Content-type' : 'application/json'}
#session.cert = CLIENT_CERTIFICATE
responses = []

count = 3
for query in queries:
    if (count == int(smartdata["dev"])):
        response.append(float(smartdata['value']))
    else:
        response = session.post(get_url, json.dumps(query))
        if response.status_code == 200:
            data = response.json()
            avg = 0
            size = len(data['series'])
            for i in range(0, size):
                avg += float(data['series'][i]['value'])
                if (size == 0):
                    with open('in4_input', 'a') as fifo:
                        fifo.write("error\n")
                        fifo.flush()
                    break
                else:
                    responses.append(float(avg/size))
        else:
            with open('in4_input', 'a') as fifo:
                fifo.write("error\n")
                fifo.flush()
            break
    count += 1

#if(len(responses) == len(dev)):
# acquired from training
#scaler = MinMaxScaler(feature_range=(0,1))
#min_max = [[-7.84084444, -8.73080809, -9.03428904,-14.21948644,-13.83044606,-19.72974329,-7.74126178, -9.67492111],
           [ 5.50026738,  8.92725544,  8.33974552, 13.83065556, 12.96539886, 20.00663538, 8.09580152, 10.58734916]]
#scaler.fit(min_max)
#scaler.transform(responses)
with open('in4_input', 'a') as fifo:
    fifo.write(responses+'\n')
    fifo.flush()
