'use strict';

System.register(['app/plugins/sdk', './css/query-editor.css!'], function (_export, _context) {
    "use strict";

    var QueryCtrl, _createClass, SmartDataDSQueryCtrl;

    function _classCallCheck(instance, Constructor) {
        if (!(instance instanceof Constructor)) {
            throw new TypeError("Cannot call a class as a function");
        }
    }

    function _possibleConstructorReturn(self, call) {
        if (!self) {
            throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
        }

        return call && (typeof call === "object" || typeof call === "function") ? call : self;
    }

    function _inherits(subClass, superClass) {
        if (typeof superClass !== "function" && superClass !== null) {
            throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
        }

        subClass.prototype = Object.create(superClass && superClass.prototype, {
            constructor: {
                value: subClass,
                enumerable: false,
                writable: true,
                configurable: true
            }
        });
        if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
    }

    return {
        setters: [function (_appPluginsSdk) {
            QueryCtrl = _appPluginsSdk.QueryCtrl;
        }, function (_cssQueryEditorCss) {}],
        execute: function () {
            _createClass = function () {
                function defineProperties(target, props) {
                    for (var i = 0; i < props.length; i++) {
                        var descriptor = props[i];
                        descriptor.enumerable = descriptor.enumerable || false;
                        descriptor.configurable = true;
                        if ("value" in descriptor) descriptor.writable = true;
                        Object.defineProperty(target, descriptor.key, descriptor);
                    }
                }

                return function (Constructor, protoProps, staticProps) {
                    if (protoProps) defineProperties(Constructor.prototype, protoProps);
                    if (staticProps) defineProperties(Constructor, staticProps);
                    return Constructor;
                };
            }();

            _export('SmartDataDSQueryCtrl', SmartDataDSQueryCtrl = function (_QueryCtrl) {
                _inherits(SmartDataDSQueryCtrl, _QueryCtrl);

                function SmartDataDSQueryCtrl($scope, $injector) {
                    _classCallCheck(this, SmartDataDSQueryCtrl);

                    var _this = _possibleConstructorReturn(this, (SmartDataDSQueryCtrl.__proto__ || Object.getPrototypeOf(SmartDataDSQueryCtrl)).call(this, $scope, $injector));

                    _this.scope = $scope;

                    _this.target.version = 0;
                    _this.target.unit = _this.target.unit || '';
                    _this.target.x = _this.target.x || '';
                    _this.target.y = _this.target.y || '';
                    _this.target.z = _this.target.z || '';
                    _this.target.r = _this.target.r || '';
                    _this.target.dev = _this.target.dev || '0';
                    //this.target.t0                = this.target.t0   || '';
                    //this.target.t1                = this.target.t1   || '';
                    _this.target.domain = _this.target.domain || 'public';
                    _this.target.username = _this.target.username || '';
                    _this.target.password = _this.target.password || '';
                    _this.target.type = _this.target.type || '';
                    _this.target.aggregator = _this.target.aggregator || '';
                    _this.target.aggregatorRange = _this.target.aggregatorRange || '';
                    _this.target.aggregatorParameter = _this.target.aggregatorParameter || '';

                    _this.target.workflow = _this.target.workflow || '0';

                    if (!_this.target.aliasMode) {
                        _this.target.aliasMode = 'default';
                        _this.target.alias = _this.datasource.getDefaultAlias(_this.target);
                    }

                    //this.target.target = this.target.target || 'select metric';
                    //this.target.type = this.target.type || 'timeseries';
                    return _this;
                }

                _createClass(SmartDataDSQueryCtrl, [{
                    key: 'getOptions',
                    value: function getOptions(query) {
                        return this.datasource.metricFindQuery(query || '');
                    }
                }, {
                    key: 'onChangeInternal',
                    value: function onChangeInternal() {
                        this.targetBlur();
                        this.panelCtrl.refresh(); // Asks the panel to refresh data.
                    }
                }, {
                    key: 'getUnits',
                    value: function getUnits() {
                        return this.datasource.getUnits(this.target);
                    }
                }, {
                    key: 'targetBlur',
                    value: function targetBlur() {
                        //this.target.errors = validateTarget(this.target);
                        if (this.target.aliasMode === 'default') {
                            this.target.alias = this.datasource.getDefaultAlias(this.target);
                        }
                        if (!_.isEqual(this.oldTarget, this.target) && _.isEmpty(this.target.errors)) {
                            this.oldTarget = angular.copy(this.target);
                            this.panelCtrl.refresh();
                        }
                    }
                }]);

                return SmartDataDSQueryCtrl;
            }(QueryCtrl));

            _export('SmartDataDSQueryCtrl', SmartDataDSQueryCtrl);

            SmartDataDSQueryCtrl.templateUrl = 'partials/query.editor.html';
        }
    };
});
//# sourceMappingURL=query_ctrl.js.map
