#!/usr/bin/php
<?php
namespace SmartData;
require_once( __DIR__ . '/../Backend.php');

/*
HT_MA2_DES_DIA (nao entendi na planilha)
HT_MA2_DES_MIN (nao entendi na planilha)
HT_MA2_ESS_EXT
HT_MA2_ESS_MIN
HT_MA2_ESS_SEG
HT_MA2_FLG_MIN
HT_MA2_INV_MIN
HT_MA2_INV_SEG
HT_MA2_MME_MIN
HT_MA2_MME_SEG
HT_MA2_SBX_MIN
HT_MA2_SBX_SEG
HT_MA2_SBX_SEG_MIN
*/

use \mysqli as mysqli;

abstract class Importer// extends Backend
{
    // mysql -h 150.162.142.228 -u Pablo -pfotovoltaica stagging_ma -A

    private static $_SERVERNAME = '150.162.142.228';
    private static $_SERVERPORT = 3306;
    private static $_DBNAME     = 'stagging_ma';
    private static $_USERNAME   = 'Pablo';
    private static $_PASSWORD   = 'fotovoltaica';

    private static $BATCH_SIZE  = PHP_INT_MAX;
    private static $DOMAIN      = 'solar_farm';

    // Checks the health of databases
    public static function health_check() : bool {
        $sucess = true;
        try {
            $conn = self::_mysqlConnect();
        } catch (\Exception $e) {
            Logger::exception($e);
            $sucess = false;
        } finally {
            $conn = null;
        }
        return $sucess;
    }

    public static function get_time(){
        list($usec, $sec) = explode(' ', microtime());
        return (float) $sec + (float) $usec;
    }

    public static function insert($backend, $series, $smartdata_batch, $j, $i, $start){
        $insertBatch_start = self::get_time();
        echo "Inserting batch...\n";
        if(!$backend->insertBatch($series, ...$smartdata_batch)){
            die ("Insertion Failed!\n");
        } else {
            echo "Inserted...\n";
        }
        $insertBatch_end = self::get_time();
        $insertBatch_elapsed_time = round($insertBatch_end - $insertBatch_start, 5);
        $total_elapsed_time = round($insertBatch_end - $start, 5);
        echo $j,'/',$i,' datapoints imported in ',$insertBatch_elapsed_time,' secs / ',$total_elapsed_time,' secs', PHP_EOL;
    }

    public static function import($table, $time, $column, $unit, $error, $confidence, $x, $y, $z, $d=0, $callback=NULL) {

        $time_start = self::get_time();
        $batch_size = self::$BATCH_SIZE;
        $count = 0;

        $smartdata = new StaticSmartData (
                $unit,
                0,      // value
                $error,
                $confidence,
                $x,
                $y,
                $z,
                0,      // timestamp
                $d      // d
        );

        $series = new Series (
                    SmartData::STATIC_VERSION,
                    $unit,    // unit
                    $x,       // x
                    $y,       // y
                    $z,       // z
                    0,        // r
                    0, //1449123538000000, // t0 (epoch in microseconds)
                    PHP_INT_MAX,  // t1 (epoch in microseconds)
                    $d      // d
        );

        global $__FORCE_VERSION;
        $__FORCE_VERSION = Config_Common::VERSION_1_1;
        $cred = new Credentials(self::$DOMAIN,
                        Config::config()::CASSANDRA_SUPERUSER,
                        Config::config()::CASSANDRA_SUPERPASS);
        $backend = new Backend_V1_1($cred, true);

        echo "Creating data series...\n";
        if(!$backend->create($series))
            die ("Create error");

        $i = 0;
        echo "Pushing data... $series ({$table}.{$column})\n";

        $servername = Importer::$_SERVERNAME;
        $port       = Importer::$_SERVERPORT;
        $dbname     = Importer::$_DBNAME;
        $username   = Importer::$_USERNAME;
        $password   = Importer::$_PASSWORD;

        $mysqli = new mysqli($servername, $username, $password, $dbname);

        if ($mysqli->connect_errno) {
            echo 'Connect failed: ', $mysqli->connect_error, PHP_EOL;
            exit();
        }

        while(true){
            $query = "SELECT UNIX_TIMESTAMP(t.{$time})*1000000 as timestamp, t.{$column} as value
                      FROM {$table} t
                      LIMIT {$count},{$batch_size};";

            echo 'new query', PHP_EOL;
            $result = $mysqli->query($query, MYSQLI_USE_RESULT);
            if(!$result){
                echo 'breaking', PHP_EOL;
                break;
            }

            if(isset($smartdata_batch))
                array_splice($smartdata_batch, 0);

            $smartdata_batch = array();
            $j = 0;
            while ($row = $result->fetch_assoc()) {
                $timestamp  = $row['timestamp'];
                $value = $row['value'];

                $smartdata->time = $timestamp;

                if (is_callable($callback))
                    $smartdata->value = $callback($value);
                else
                    $smartdata->value = $value;

                $smartdata_temp = clone $smartdata;
                array_push($smartdata_batch, $smartdata_temp);

                $i = $i + 1;
                $j = $j + 1;
                if($j >= 20000){
                    self::insert($backend, $series, $smartdata_batch, $j, $i, $time_start);
                    array_splice($smartdata_batch, 0);
                    $j = 0;
                }
            }
            if($j > 0){
                self::insert($backend, $series, $smartdata_batch, $j, $i, $time_start);
                array_splice($smartdata_batch, 0);
            }


            $count+=$batch_size;

            $result->close();
        }

        $mysqli->close();

        $time_end = self::get_time();
        $elapsed_time = round($time_end - $time_start, 5);

        echo "Import finished: {$table}.{$column}  Total points: {$i}\n";
        echo 'Elapsed time: ', $elapsed_time, ' secs. Memory usage: ', round(((memory_get_peak_usage(true) / 1024) / 1024), 2), 'Mb';
        echo "________________________________________________\n";

    }

    private static function _mysqlConnect() : \PDO {
        $servername = Importer::$_SERVERNAME;
        $port       = Importer::$_SERVERPORT;
        $dbname     = Importer::$_DBNAME;
        $username   = Importer::$_USERNAME;
        $password   = Importer::$_PASSWORD;
        $conn = new \PDO("mysql:host=$servername;port=$port;dbname=$dbname", $username, $password);
        $conn->setAttribute(\PDO::ATTR_ERRMODE, \PDO::ERRMODE_EXCEPTION);
        $conn->setAttribute(\PDO::ATTR_PERSISTENT, true);
        $conn->setAttribute(\PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, false);
        return $conn;
    }
}

if (!Importer::health_check())
    die ("Authentication failure\n");

$__FORCE_SCREEN_LOG = true;

//                         si      | mod     | sr            | rad           |  m            |  kg           |  s            |  A            |  K            |  mol          |  cd
const Irradiance         = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 0) << 18 | (4 + 1) << 15 | (4 - 3) << 12 | (4 + 0) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Speed              = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 1) << 18 | (4 + 0) << 15 | (4 - 1) << 12 | (4 + 0) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Temperature        = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 0) << 18 | (4 + 0) << 15 | (4 + 0) << 12 | (4 + 0) << 9  | (4 + 1) << 6  | (4 + 0) << 3  | (4 + 0);
const Length             = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 1) << 18 | (4 + 0) << 15 | (4 + 0) << 12 | (4 + 0) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Pressure           = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 - 1) << 18 | (4 + 1) << 15 | (4 - 2) << 12 | (4 + 0) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Electric_Potential = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 2) << 18 | (4 + 1) << 15 | (4 - 3) << 12 | (4 - 1) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Current            = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 0) << 18 | (4 + 0) << 15 | (4 + 0) << 12 | (4 + 1) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Electric_Power     = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 2) << 18 | (4 + 1) << 15 | (4 - 3) << 12 | (4 + 0) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);
const Electrical_Energy  = 1 << 31 | 0 << 27 | (4 + 0) << 24 | (4 + 0) << 21 | (4 + 2) << 18 | (4 + 1) << 15 | (4 - 2) << 12 | (4 + 0) << 9  | (4 + 0) << 6  | (4 + 0) << 3  | (4 + 0);


//HT_MA2 - Aratiba
$x =  3464.414 * 100000;  // km to cm
$y = -4485.464 * 100000;  // km to cm
$z = -2917.097 * 100000;  // km to cm


//HT_MA4 - Itiquira

$mbar_to_pascal     = function($milibar){ return ($milibar/1000)*100000; };
$gcel_to_kelv  =      function($celsius){ return $celsius+274.15; };
$mm_to_m            = function($millimeters){ return $millimeters/1000; };
$k_to_none          = function($k){ return $k*1000; };
$kWh_to_Ws          = function($kWh){ return $kWh*3600000; };


// HT_MA2_ESS_MIN = 794726 (106 secs)
// HT_MA2_ESS_SEG = 46763570

//public static function import($table, $time, $column, $unit, $error, $confidence, $x, $y, $z, $d=0, $callback=NULL);

//nohup ./importSolarFarm.php 2>&1 >> log &

// OK =============================================================================================
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'AV_M2000002', Temperature,        0,0, $x,$y,$z, 0, $gcel_to_kelv);        // M2000002  MA2 - ESS - TEMPERATURA INTERNA DATALOGGER       (K)
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'MN_M2000003', Electric_Potential, 0,0, $x,$y,$z, 0, null);                 // M2000003  MA2 - ESS - TENSÃO DA BATERIA DATALOGGER         (V) kg.m^2/(s^3.A)
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'AV_M2000004', Temperature,        0,0, $x,$y,$z, 1, $gcel_to_kelv);        // M2000004  MA2 - ESS - TEMPERATURA AMBIENTE                 (K)
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'AV_M2000006', Speed,              0,0, $x,$y,$z, 0, null);                 // M2000006  MA2 - ESS - VELOCIDADE DO VENTO                  (m/s)
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'AV_M2000008', Pressure,           0,0, $x,$y,$z, 0, $mbar_to_pascal);      // M2000008  MA2 - ESS - PRESSÃO BAROMÉTRICA                  (Pa) kg/(m.s^2) [1 bar = 100000 Pa]
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'TT_M2000009', Length,             0,0, $x,$y,$z, 0, $mm_to_m);             // M2000009  MA2 - ESS - ÍNDICE PLUVIOMÉTRICO                 (m)

//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000010', Irradiance,         0,0, $x,$y,$z, 0, null);                 // M2000010  MA2 - ESS - IRRADIÂNCIA HORIZONTAL               (W/m2)
//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000011', Irradiance,         0,0, $x,$y,$z, 1, null);                 // M2000011  MA2 - ESS - IRRADIÂNCIA INCLINADA                (W/m2)
//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000012', Irradiance,         0,0, $x,$y,$z, 2, null);                 // M2000012  MA2 - ESS - IRRADIÂNCIA INCLINADA (CÉLULA LIMPA) (W/m2)
//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000013', Irradiance,         0,0, $x,$y,$z, 3, null);                 // M2000013  MA2 - ESS - IRRADIÂNCIA INCLINADA (CÉLULA SUJA)  (W/m2)
//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000014', Irradiance,         0,0, $x,$y,$z, 4, null);                 // M2000014  MA2 - ESS - IRRADIÂNCIA GLOBAL                   (W/m2)
//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000015', Irradiance,         0,0, $x,$y,$z, 5, null);                 // M2000015  MA2 - ESS - IRRADIÂNCIA DIFUSA                   (W/m2)
//Importer::import('HT_MA2_ESS_SEG', 'TS_SAMPLETM', 'VL_M2000016', Irradiance,         0,0, $x,$y,$z, 6, null);                 // M2000016  MA2 - ESS - IRRADIÂNCIA DIRETA                   (W/m2)

// TO IMPORT ======================================================================================
exit;
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'AV_M2000005', 0000000000000000,   0,0, $x,$y,$z, 0, null);                 // M2000005  MA2 - ESS - UMIDADE RELATIVA                     (%)
//Importer::import('HT_MA2_ESS_MIN', 'TS_SAMPLETM', 'AV_M2000007', 0000000000000000,   0,0, $x,$y,$z, 0, null);                 // M2000007  MA2 - ESS - DIREÇÃO DO VENTO                     (grau)
//
//
//
//
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000100', un, er, cnf, x, y, z, d, clbk);                              // M2000100  MA2 - ASI - STRINGBOX - VMU-M DATALOGGER 1 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000101', un, er, cnf, x, y, z, d, clbk);                              // M2000101  MA2 - ASI - STRINGBOX - VMU-M DATALOGGER 1 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000103', Temperature,        0,0, $x,$y,$z, 1001, $gcel_to_kelv);     // M2000103  MA2 - ASI - STRINGBOX - VMU-M DATALOGGER 1 - TEMPERATURA MÓDULOS  (K)
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000107', 0000000000000000,   0,0, $x,$y,$z, 1001, clbk);              // M2000107  MA2 - ASI - STRINGBOX - VMU-S STRING 1 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000108', 0000000000000000,   0,0, $x,$y,$z, 1001, clbk);              // M2000108  MA2 - ASI - STRINGBOX - VMU-S STRING 1 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000109', Electric_Potential, 0,0, $x,$y,$z, 1001, null);              // M2000109  MA2 - ASI - STRINGBOX - VMU-S STRING 1 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000110', Current,            0,0, $x,$y,$z, 1001, null);              // M2000110  MA2 - ASI - STRINGBOX - VMU-S STRING 1 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000111', Electric_Power,     0,0, $x,$y,$z, 1001, $k_to_none);        // M2000111  MA2 - ASI - STRINGBOX - VMU-S STRING 1 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000113', Electrical_Energy,  0,0, $x,$y,$z, 1001, $kWh_to_Ws);        // M2000113  MA2 - ASI - STRINGBOX - VMU-S STRING 1 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000114', 0000000000000000,   0,0, $x,$y,$z, 1002, clbk);              // M2000114  MA2 - ASI - STRINGBOX - VMU-S STRING 2 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000115', 0000000000000000,   0,0, $x,$y,$z, 1002, clbk);              // M2000115  MA2 - ASI - STRINGBOX - VMU-S STRING 2 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000116', Electric_Potential, 0,0, $x,$y,$z, 1002, null);              // M2000116  MA2 - ASI - STRINGBOX - VMU-S STRING 2 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000117', Current,            0,0, $x,$y,$z, 1002, null);              // M2000117  MA2 - ASI - STRINGBOX - VMU-S STRING 2 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000118', Electric_Power,     0,0, $x,$y,$z, 1002, $k_to_none);        // M2000118  MA2 - ASI - STRINGBOX - VMU-S STRING 2 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000120', Electrical_Energy,  0,0, $x,$y,$z, 1002, $kWh_to_Ws);        // M2000120  MA2 - ASI - STRINGBOX - VMU-S STRING 2 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000121', 0000000000000000,   0,0, $x,$y,$z, 1003, clbk);              // M2000121  MA2 - ASI - STRINGBOX - VMU-S STRING 3 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000122', 0000000000000000,   0,0, $x,$y,$z, 1003, clbk);              // M2000122  MA2 - ASI - STRINGBOX - VMU-S STRING 3 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000123', Electric_Potential, 0,0, $x,$y,$z, 1003, null);              // M2000123  MA2 - ASI - STRINGBOX - VMU-S STRING 3 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000124', Current,            0,0, $x,$y,$z, 1003, null);              // M2000124  MA2 - ASI - STRINGBOX - VMU-S STRING 3 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000125', Electric_Power,     0,0, $x,$y,$z, 1003, $k_to_none);        // M2000125  MA2 - ASI - STRINGBOX - VMU-S STRING 3 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000127', Electrical_Energy,  0,0, $x,$y,$z, 1003, $kWh_to_Ws);        // M2000127  MA2 - ASI - STRINGBOX - VMU-S STRING 3 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000128', 0000000000000000,   0,0, $x,$y,$z, 1004, clbk);              // M2000128  MA2 - ASI - STRINGBOX - VMU-S STRING 4 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000129', 0000000000000000,   0,0, $x,$y,$z, 1004, clbk);              // M2000129  MA2 - ASI - STRINGBOX - VMU-S STRING 4 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000130', Electric_Potential, 0,0, $x,$y,$z, 1004, null);              // M2000130  MA2 - ASI - STRINGBOX - VMU-S STRING 4 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000131', Current,            0,0, $x,$y,$z, 1004, null);              // M2000131  MA2 - ASI - STRINGBOX - VMU-S STRING 4 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000132', Electric_Power,     0,0, $x,$y,$z, 1004, $k_to_none);        // M2000132  MA2 - ASI - STRINGBOX - VMU-S STRING 4 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000134', Electrical_Energy,  0,0, $x,$y,$z, 1004, $kWh_to_Ws);        // M2000134  MA2 - ASI - STRINGBOX - VMU-S STRING 4 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000135', 0000000000000000,   0,0, $x,$y,$z, 1005, clbk);              // M2000135  MA2 - ASI - STRINGBOX - VMU-S STRING 5 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000136', 0000000000000000,   0,0, $x,$y,$z, 1005, clbk);              // M2000136  MA2 - ASI - STRINGBOX - VMU-S STRING 5 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000137', Electric_Potential, 0,0, $x,$y,$z, 1005, null);              // M2000137  MA2 - ASI - STRINGBOX - VMU-S STRING 5 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000138', Current,            0,0, $x,$y,$z, 1005, null);              // M2000138  MA2 - ASI - STRINGBOX - VMU-S STRING 5 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000139', Electric_Power,     0,0, $x,$y,$z, 1005, $k_to_none);        // M2000139  MA2 - ASI - STRINGBOX - VMU-S STRING 5 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000141', Electrical_Energy,  0,0, $x,$y,$z, 1005, $kWh_to_Ws);        // M2000141  MA2 - ASI - STRINGBOX - VMU-S STRING 5 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000142', 0000000000000000,   0,0, $x,$y,$z, 1006, clbk);              // M2000142  MA2 - ASI - STRINGBOX - VMU-S STRING 6 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000143', 0000000000000000,   0,0, $x,$y,$z, 1006, clbk);              // M2000143  MA2 - ASI - STRINGBOX - VMU-S STRING 6 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000144', Electric_Potential, 0,0, $x,$y,$z, 1006, null);              // M2000144  MA2 - ASI - STRINGBOX - VMU-S STRING 6 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000145', Current,            0,0, $x,$y,$z, 1006, null);              // M2000145  MA2 - ASI - STRINGBOX - VMU-S STRING 6 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000146', Electric_Power,     0,0, $x,$y,$z, 1006, $k_to_none);        // M2000146  MA2 - ASI - STRINGBOX - VMU-S STRING 6 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000148', Electrical_Energy,  0,0, $x,$y,$z, 1006, $kWh_to_Ws);        // M2000148  MA2 - ASI - STRINGBOX - VMU-S STRING 6 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000149', 0000000000000000,   0,0, $x,$y,$z, 1007, clbk);              // M2000149  MA2 - ASI - STRINGBOX - VMU-S STRING 7 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000150', 0000000000000000,   0,0, $x,$y,$z, 1007, clbk);              // M2000150  MA2 - ASI - STRINGBOX - VMU-S STRING 7 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000151', Electric_Potential, 0,0, $x,$y,$z, 1007, null);              // M2000151  MA2 - ASI - STRINGBOX - VMU-S STRING 7 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000152', Current,            0,0, $x,$y,$z, 1007, null);              // M2000152  MA2 - ASI - STRINGBOX - VMU-S STRING 7 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000153', Electric_Power,     0,0, $x,$y,$z, 1007, $k_to_none);        // M2000153  MA2 - ASI - STRINGBOX - VMU-S STRING 7 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000155', Electrical_Energy,  0,0, $x,$y,$z, 1007, $kWh_to_Ws);        // M2000155  MA2 - ASI - STRINGBOX - VMU-S STRING 7 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000156', 0000000000000000,   0,0, $x,$y,$z, 1008, clbk);              // M2000156  MA2 - ASI - STRINGBOX - VMU-S STRING 8 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000157', 0000000000000000,   0,0, $x,$y,$z, 1008, clbk);              // M2000157  MA2 - ASI - STRINGBOX - VMU-S STRING 8 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000158', Electric_Potential, 0,0, $x,$y,$z, 1008, null);              // M2000158  MA2 - ASI - STRINGBOX - VMU-S STRING 8 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000159', Current,            0,0, $x,$y,$z, 1008, null);              // M2000159  MA2 - ASI - STRINGBOX - VMU-S STRING 8 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000160', Electric_Power,     0,0, $x,$y,$z, 1008, $k_to_none);        // M2000160  MA2 - ASI - STRINGBOX - VMU-S STRING 8 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000162', Electrical_Energy,  0,0, $x,$y,$z, 1008, $kWh_to_Ws);        // M2000162  MA2 - ASI - STRINGBOX - VMU-S STRING 8 - ENERGIA CC               (Ws) kg.m^2.s/s^3
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000163', 0000000000000000,   0,0, $x,$y,$z, 1009, clbk);              // M2000163  MA2 - ASI - STRINGBOX - VMU-S STRING 9 - CÓDIGO DO MÓDULO
////Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000164', 0000000000000000,   0,0, $x,$y,$z, 1009, clbk);              // M2000164  MA2 - ASI - STRINGBOX - VMU-S STRING 9 - ESTADO DO MÓDULO
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000165', Electric_Potential, 0,0, $x,$y,$z, 1009, null);              // M2000165  MA2 - ASI - STRINGBOX - VMU-S STRING 9 - TENSÃO CC                (V)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000166', Current,            0,0, $x,$y,$z, 1009, null);              // M2000166  MA2 - ASI - STRINGBOX - VMU-S STRING 9 - CORRENTE CC              (A)
//  Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000167', Electric_Power,     0,0, $x,$y,$z, 1009, $k_to_none);        // M2000167  MA2 - ASI - STRINGBOX - VMU-S STRING 9 - POTÊNCIA CC              (W) kg.m^2/s^3
//  Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000169', Electrical_Energy,  0,0, $x,$y,$z, 1009, $kWh_to_Ws);        // M2000169  MA2 - ASI - STRINGBOX - VMU-S STRING 9 - ENERGIA CC               (Ws) kg.m^2.s/s^3



//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000170', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000171', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000177', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000178', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000179', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000180', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000181', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000183', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000184', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000185', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000190', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000191', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000192', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000197', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000198', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000199', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000204', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000205', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000206', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000211', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000212', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000213', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000218', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000219', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000220', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000225', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000226', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000227', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000232', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000233', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000234', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000239', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000240', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000241', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000243', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000247', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000248', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000253', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000254', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000255', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000260', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000261', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000262', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000267', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000268', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000269', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000274', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000275', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000276', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000281', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000282', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000283', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000288', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000289', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000290', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000295', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000296', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000297', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000302', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000303', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000304', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000309', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000310', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000311', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000316', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000317', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000318', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000323', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000331', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000332', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000337', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000324', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000325', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000338', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000339', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000344', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000345', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000346', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000351', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000352', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000353', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000358', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000359', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000360', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000365', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000366', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000367', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000372', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000373', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000374', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000379', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000380', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000381', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000386', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000387', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000388', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000393', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000394', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000395', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000400', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000401', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000402', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000404', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000408', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000409', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000411', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000413', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000414', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000415', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000420', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000421', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000422', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000427', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000428', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000429', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000431', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000435', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000436', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000441', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000442', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000443', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000448', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000449', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000450', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000452', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000456', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000457', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000462', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000463', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000464', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000469', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000470', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000471', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000476', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000477', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000478', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000483', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000484', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000485', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000490', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000491', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000492', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000497', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000498', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000499', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000504', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000505', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000506', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000511', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000512', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000513', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000518', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000519', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000520', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000522', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000526', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000527', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000532', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000533', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000534', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000539', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000540', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000541', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000546', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000547', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000548', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000553', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000554', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000555', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000560', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000561', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000562', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000567', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000568', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000569', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000574', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000575', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000576', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000581', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000582', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000583', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000588', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000589', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000590', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000595', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000596', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000597', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000602', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000603', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000604', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000609', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000610', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000611', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000616', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000617', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000618', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000623', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000624', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000625', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000627', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000631', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000632', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000634', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000636', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000637', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000638', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000643', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000644', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000645', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000650', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000651', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000652', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000657', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000658', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000659', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000664', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000665', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000666', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000671', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000672', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000673', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_MIN', 'TS_SAMPLETM', 'VL_M2000678', un, er, cnf, x, y, z, d, clbk);


// HT_MA2_INV_MIN ------------------------------------------------------------------------
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001000', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001001', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001002', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001003', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001004', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001005', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001006', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001007', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001008', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001009', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001010', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001011', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001012', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001013', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001014', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001015', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001016', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001017', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001018', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001019', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001020', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001022', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001030', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001037', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001038', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001039', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001040', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001041', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001042', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001043', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001044', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001046', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001054', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001061', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001062', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001063', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001064', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001065', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001066', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001067', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001068', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001070', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001078', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001085', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001086', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001087', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001088', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001089', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001090', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001091', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001092', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001094', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001102', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001109', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001110', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001111', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001112', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001113', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001114', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001115', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001116', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001118', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001126', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001133', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001134', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001135', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001136', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001137', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001138', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001139', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001140', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001142', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001150', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001157', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001158', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001159', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001160', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001161', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001162', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001163', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001164', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001166', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001174', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001181', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001182', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_MIN', 'TS_SAMPLETM', 'VL_M2001183', un, er, cnf, x, y, z, d, clbk);



// HT_MA2_INV_SEG ------------------------------------------------------------------------
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001027', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001028', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001029', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001031', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001032', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001033', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001034', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001035', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001036', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001051', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001052', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001053', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001055', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001056', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001057', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001058', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001059', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001060', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001075', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001076', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001077', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001079', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001080', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001081', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001082', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001083', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001084', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001099', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001100', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001101', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001103', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001104', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001105', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001106', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001107', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001108', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001123', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001124', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001125', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001127', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001128', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001129', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001130', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001131', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001132', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001147', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001148', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001149', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001151', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001152', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001153', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001154', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001155', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001156', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001171', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001172', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001173', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001175', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001176', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001177', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001178', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001179', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_INV_SEG', 'TS_SAMPLETM', 'VL_M2001180', un, er, cnf, x, y, z, d, clbk);


// HT_MA2_MME_SEG ------------------------------------------------------------------------
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002006', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002007', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002008', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002023', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002025', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002026', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002027', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002028', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002065', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002066', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002067', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002082', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002084', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002085', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002086', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002087', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002124', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002125', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002126', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002141', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002143', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002144', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002145', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002146', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002183', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002184', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002185', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002200', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002202', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002203', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002204', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002205', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002242', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002243', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002244', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002259', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002261', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002262', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002263', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002264', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002301', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002302', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002303', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002318', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002320', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002321', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002322', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002323', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002360', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002361', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002362', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002377', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002379', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002380', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002381', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002382', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002419', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002420', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002421', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002436', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002438', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002439', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002440', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_SEG', 'TS_SAMPLETM', 'VL_M2002441', un, er, cnf, x, y, z, d, clbk);


// HT_MA2_MME_MIN ------------------------------------------------------------------------
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002000', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002001', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002002', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002003', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002004', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002005', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002009', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002010', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002011', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002012', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002013', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002014', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002015', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002016', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002017', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002018', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002019', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002020', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002021', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002022', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002024', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002029', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002030', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002031', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002032', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002033', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002034', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002035', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002036', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002037', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002038', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002039', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002040', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002041', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002042', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002043', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002044', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002045', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002046', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002047', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002048', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002049', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002050', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002051', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002052', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002053', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002054', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002055', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002056', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002057', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002058', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002059', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002060', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002061', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002062', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002063', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002064', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002068', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002069', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002070', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002071', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002072', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002073', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002074', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002075', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002076', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002077', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002078', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002079', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002080', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002081', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002083', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002088', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002089', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002090', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002091', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002092', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002093', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002094', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002095', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002096', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002097', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002098', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002099', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002100', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002101', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002102', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002103', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002104', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002105', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002106', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002107', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002108', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002109', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002110', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002111', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002112', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002113', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002114', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002115', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002116', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002117', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002118', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002119', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002120', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002121', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002122', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002123', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002127', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002128', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002129', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002130', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002131', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002132', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002133', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002134', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002135', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002136', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002137', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002138', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002139', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002140', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002142', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002147', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002148', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002149', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002150', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002151', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002152', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002153', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002154', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002155', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002156', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002157', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002158', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002159', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002160', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002161', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002162', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002163', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002164', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002165', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002166', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002167', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002168', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002169', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002170', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002171', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002172', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002173', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002174', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002175', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002176', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002177', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002178', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002179', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002180', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002181', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002182', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002186', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002187', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002188', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002189', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002190', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002191', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002192', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002193', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002194', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002195', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002196', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002197', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002198', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002199', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002201', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002206', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002207', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002208', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002209', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002210', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002211', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002212', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002213', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002214', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002215', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002216', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002217', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002218', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002219', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002220', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002221', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002222', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002223', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002224', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002225', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002226', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002227', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002228', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002229', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002230', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002231', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002232', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002233', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002234', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002235', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002236', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002237', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002238', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002239', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002240', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002241', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002245', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002246', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002247', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002248', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002249', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002250', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002251', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002252', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002253', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002254', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002255', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002256', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002257', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002258', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002260', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002265', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002266', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002267', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002268', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002269', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002270', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002271', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002272', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002273', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002274', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002275', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002276', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002277', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002278', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002279', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002280', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002281', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002282', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002283', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002284', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002285', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002286', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002287', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002288', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002289', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002290', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002291', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002292', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002293', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002294', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002295', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002296', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002297', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002298', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002299', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002300', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002304', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002305', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002306', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002307', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002308', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002309', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002310', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002311', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002312', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002313', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002314', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002315', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002316', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002317', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002319', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002324', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002325', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002326', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002327', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002328', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002329', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002330', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002331', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002332', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002333', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002334', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002335', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002336', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002337', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002338', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002339', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002340', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002341', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002342', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002343', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002344', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002345', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002346', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002347', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002348', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002349', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002350', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002351', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002352', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002353', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002354', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002355', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002356', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002357', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002358', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002359', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002363', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002364', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002365', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002366', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002367', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002368', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002369', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002370', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002371', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002372', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002373', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002374', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002375', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002376', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002378', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002383', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002384', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002385', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002386', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002387', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002388', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002389', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002390', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002391', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002392', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002393', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002394', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002395', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002396', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002397', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002398', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002399', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002400', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002401', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002402', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002403', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002404', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002405', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002406', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002407', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002408', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002409', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002410', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002411', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002412', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002413', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002414', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002415', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002416', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002417', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002418', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002422', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002423', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002424', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002425', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002426', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002427', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002428', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002429', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002430', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002431', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002432', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002433', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002434', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002435', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002437', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002442', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002443', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002444', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002445', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002446', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002447', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002448', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002449', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002450', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002451', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002452', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002453', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002454', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002455', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002456', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002457', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002458', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002459', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002460', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002461', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002462', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002463', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002464', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002465', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002466', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002467', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002468', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002469', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002470', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_MME_MIN', 'TS_SAMPLETM', 'VL_M2002471', un, er, cnf, x, y, z, d, clbk);


// HT_MA2_SBX_SEG ------------------------------------------------------------------------






//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000186', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000187', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000188', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000193', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000194', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000195', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000200', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000201', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000202', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000207', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000208', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000209', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000214', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000215', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000216', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000221', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000222', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000223', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000228', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000229', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000230', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000235', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000236', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000237', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000249', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000250', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000251', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000256', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000257', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000258', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000263', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000264', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000265', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000270', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000271', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000272', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000277', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000278', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000279', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000284', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000285', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000286', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000291', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000292', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000293', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000298', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000299', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000300', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000305', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000306', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000307', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000312', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000313', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000314', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000319', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000320', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000321', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000333', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000334', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000335', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000340', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000341', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000342', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000347', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000348', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000349', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000354', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000355', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000356', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000361', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000362', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000363', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000368', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000369', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000370', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000375', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000376', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000377', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000382', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000383', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000384', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000389', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000390', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000391', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000396', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000397', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000398', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000412', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000416', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000417', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000418', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000423', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000424', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000425', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000437', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000438', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000439', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000444', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000445', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000446', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000458', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000459', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000460', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000465', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000466', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000467', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000472', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000473', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000474', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000479', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000480', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000481', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000486', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000487', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000488', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000493', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000494', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000495', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000500', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000501', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000502', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000507', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000508', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000509', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000514', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000515', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000516', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000528', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000529', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000530', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000535', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000536', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000537', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000542', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000543', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000544', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000549', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000550', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000551', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000556', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000557', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000558', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000563', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000564', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000565', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000570', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000571', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000572', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000577', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000578', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000579', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000584', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000585', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000586', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000591', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000592', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000593', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000598', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000599', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000600', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000605', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000606', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000607', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000612', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000613', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000614', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000619', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000620', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000621', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000635', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000639', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000640', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000641', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000646', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000647', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000648', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000653', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000654', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000655', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000660', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000661', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000662', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000667', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000668', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000669', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000674', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000675', un, er, cnf, x, y, z, d, clbk);
//Importer::import('HT_MA2_SBX_SEG', 'TS_SAMPLETM', 'VL_M2000676', un, er, cnf, x, y, z, d, clbk);
